## proxygen 2021.01.04.00

=== CMakeLists.txt ===
# Copyright (c) Facebook, Inc. and its affiliates.
# All rights reserved.
#
# This source code is licensed under the BSD-style license found in the
# LICENSE file in the root directory of this source tree.

cmake_minimum_required(VERSION 3.10)
include(CheckCXXCompilerFlag)

project(
    proxygen
)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

set(CMAKE_MODULE_PATH
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake"
  # for in-fbsource builds
  "${CMAKE_CURRENT_SOURCE_DIR}/../opensource/fbcode_builder/CMake"
  # For shipit-transformed builds
  "${CMAKE_CURRENT_SOURCE_DIR}/build/fbcode_builder/CMake"
  ${CMAKE_MODULE_PATH})

option(BUILD_SHARED_LIBS
  "If enabled, build proxygen as a shared library.  \
  This is generally discouraged, since proxygen does not commit to having \
  a stable ABI."
  OFF
)
# Mark BUILD_SHARED_LIBS as an "advanced" option, since enabling it
# is generally discouraged.
mark_as_advanced(BUILD_SHARED_LIBS)

include(FBBuildOptions)
fb_activate_static_library_option()

# PROXYGEN_FBCODE_ROOT is where the top level proxygen/ directory resides, so
# an #include <proxygen/path/to/file> will resolve to
# $PROXYGEN_FBCODE_ROOT/proxygen/path/to/file on disk
set(PROXYGEN_FBCODE_ROOT ${CMAKE_CURRENT_SOURCE_DIR})

# Similarly, PROXYGEN_GENERATED_ROOT is where the top level proxygen/ directory
# resides for generated files, so a #include <proxygen/path/to/generated/file>
# will be at $PROXYGEN_GENERATED_ROOT/proxygen/path/to/generated/file
set(PROXYGEN_GENERATED_ROOT ${CMAKE_CURRENT_BINARY_DIR}/generated)
file(MAKE_DIRECTORY ${PROXYGEN_GENERATED_ROOT})

# Build-time program requirements.
find_program(PROXYGEN_PYTHON python3)
if(NOT PROXYGEN_PYTHON)
    message(FATAL_ERROR "python is required for the proxygen build")
endif()

find_program(PROXYGEN_GPERF gperf)
if(NOT PROXYGEN_GPERF)
    message(FATAL_ERROR "gperf is required for the proxygen build")
endif()

# Dependencies
#
# IMPORTANT: If you change this, make the analogous update in:
#   cmake/proxygen-config.cmake.in
find_package(fmt REQUIRED)
find_package(folly REQUIRED)
find_package(wangle REQUIRED)
if (BUILD_QUIC)
  find_package(mvfst REQUIRED)
else()
 find_package(Fizz REQUIRED)
endif()
find_package(Zstd REQUIRED)
find_package(ZLIB REQUIRED)
find_package(OpenSSL REQUIRED)
find_package(Threads)
find_package(Boost 1.58 REQUIRED
  COMPONENTS
    iostreams
    context
    date_time
    filesystem
    program_options
    regex
    system
    thread
)

list(APPEND
    _PROXYGEN_COMMON_COMPILE_OPTIONS
    -Wall
    -Wextra
)

CHECK_CXX_COMPILER_FLAG(-Wnoexcept-type COMPILER_HAS_W_NOEXCEPT_TYPE)
if (COMPILER_HAS_W_NOEXCEPT_TYPE)
  list(APPEND _PROXYGEN_COMMON_COMPILE_OPTIONS -Wno-noexcept-type)
endif()
CHECK_CXX_COMPILER_FLAG(-Wunused-parameter COMPILER_HAS_W_UNUSED_PARAMETER)
if (COMPILER_HAS_W_UNUSED_PARAMETER)
  list(APPEND _PROXYGEN_COMMON_COMPILE_OPTIONS -Wno-unused-parameter)
endif()
CHECK_CXX_COMPILER_FLAG(-Wmissing-field-initializers COMPILER_HAS_W_MISSING_FIELD_INITIALIZERS)
if (COMPILER_HAS_W_MISSING_FIELD_INITIALIZERS)
  list(APPEND _PROXYGEN_COMMON_COMPILE_OPTIONS -Wno-missing-field-initializers)
endif()
CHECK_CXX_COMPILER_FLAG(-Wnullability-completeness COMPILER_HAS_W_NULLABILITY_COMPLETENESS)
if (COMPILER_HAS_W_NULLABILITY_COMPLETENESS)
    list(APPEND _PROXYGEN_COMMON_COMPILE_OPTIONS -Wno-nullability-completeness)
endif()
CHECK_CXX_COMPILER_FLAG(-Wdeprecated-register COMPILER_HAS_W_DEPRECATED_REGISTER)
if (COMPILER_HAS_W_DEPRECATED_REGISTER)
    list(APPEND _PROXYGEN_COMMON_COMPILE_OPTIONS -Wno-deprecated-register)
endif()
CHECK_CXX_COMPILER_FLAG(-Wunused-value COMPILER_HAS_W_UNUSED_VALUE)
if (COMPILER_HAS_W_UNUSED_VALUE)
    list(APPEND _PROXYGEN_COMMON_COMPILE_OPTIONS -Wno-unused-value)
endif()

SET(GFLAG_DEPENDENCIES "")
SET(PROXYGEN_EXTRA_LINK_LIBRARIES "")
SET(PROXYGEN_EXTRA_INCLUDE_DIRECTORIES "")

find_package(gflags CONFIG QUIET)
if (gflags_FOUND)
  message("module path: ${CMAKE_MODULE_PATH}")
  message(STATUS "Found gflags from package config")
  if (TARGET gflags-shared)
    list(APPEND GFLAG_DEPENDENCIES gflags-shared)
  elseif (TARGET gflags)
    list(APPEND GFLAG_DEPENDENCIES gflags)
  else()
    message(FATAL_ERROR
            "Unable to determine the target name for the GFlags package.")
  endif()
  list(APPEND CMAKE_REQUIRED_LIBRARIES ${GFLAGS_LIBRARIES})
  list(APPEND CMAKE_REQUIRED_INCLUDES ${GFLAGS_INCLUDE_DIR})
else()
  find_package(Gflags REQUIRED MODULE)
  list(APPEND PROXYGEN_EXTRA_LINK_LIBRARIES ${LIBGFLAGS_LIBRARY})
  list(APPEND PROXYGEN_EXTRA_INCLUDE_DIRECTORIES ${LIBGFLAGS_INCLUDE_DIR})
  list(APPEND CMAKE_REQUIRED_LIBRARIES ${LIBGFLAGS_LIBRARY})
  list(APPEND CMAKE_REQUIRED_INCLUDES ${LIBGFLAGS_INCLUDE_DIR})
endif()

include(ProxygenTest)

add_subdirectory(proxygen)

install(
    EXPORT proxygen-exports
    FILE proxygen-targets.cmake
    NAMESPACE proxygen::
    DESTINATION lib/cmake/proxygen/
)
include(CMakePackageConfigHelpers)
configure_package_config_file(
    cmake/proxygen-config.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/proxygen-config.cmake
    INSTALL_DESTINATION lib/cmake/proxygen/
)
install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/proxygen-config.cmake
    DESTINATION lib/cmake/proxygen/
)

# uninstall target
if(NOT TARGET uninstall)
    configure_file(
        "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
        "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
        IMMEDIATE @ONLY)

    add_custom_target(uninstall
        COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
endif()

=== proxygen/CMakeLists.txt ===
# Copyright (c) Facebook, Inc. and its affiliates.
# All rights reserved.
#
# This source code is licensed under the BSD-style license found in the
# LICENSE file in the root directory of this source tree.

add_subdirectory(external)
add_subdirectory(lib)
add_subdirectory(httpserver)
add_subdirectory(httpclient)
add_subdirectory(fuzzers)

=== proxygen/external/CMakeLists.txt ===
# Copyright (c) Facebook, Inc. and its affiliates.
# All rights reserved.
#
# This source code is licensed under the BSD-style license found in the
# LICENSE file in the root directory of this source tree.

add_library(
    proxygen_http_parser OBJECT
    http_parser/http_parser_cpp.cpp
)

target_compile_options(
    proxygen_http_parser PRIVATE
    ${_PROXYGEN_COMMON_COMPILE_OPTIONS}
)

if (BUILD_SHARED_LIBS)
  set_property(TARGET proxygen_http_parser PROPERTY POSITION_INDEPENDENT_CODE ON)
endif()

target_include_directories(
    proxygen_http_parser PRIVATE
    ${PROXYGEN_FBCODE_ROOT}
)
install(FILES http_parser/http_parser.h DESTINATION
        include/proxygen/external/http_parser)

=== proxygen/fuzzers/CMakeLists.txt ===
# Copyright (c) Facebook, Inc. and its affiliates.
# All rights reserved.
#
# This source code is licensed under the BSD-style license found in the
# LICENSE file in the root directory of this source tree.

function(proxygen_add_fuzzer)
    if(NOT BUILD_FUZZERS)
        return()
    endif()

    set(options)
    set(one_value_args TARGET WORKING_DIRECTORY PREFIX)
    set(multi_value_args SOURCES DEPENDS INCLUDES EXTRA_ARGS)
    cmake_parse_arguments(PARSE_ARGV 0 PROXYGEN_FUZZ "${options}" "${one_value_args}" "${multi_value_args}")

    # Remove any references to the main we have from gmock
    # So we can use the one provided by the fuzzing engine
    set(LIBGMOCK_LIBRARIES_NO_MAIN ${LIBGMOCK_LIBRARIES})
    list(REMOVE_ITEM
         LIBGMOCK_LIBRARIES_NO_MAIN
         "${GTEST_BINARY_DIR}/${CMAKE_CFG_INTDIR}/googlemock/${CMAKE_STATIC_LIBRARY_PREFIX}gmock_main${CMAKE_STATIC_LIBRARY_SUFFIX}"
         gmock_main
         gmock_maind
         GTest::gmock_main
    )

    if(NOT PROXYGEN_FUZZ_TARGET)
      message(FATAL_ERROR "The TARGET parameter is mandatory.")
    endif()

    if(NOT PROXYGEN_FUZZ_SOURCES)
      set(PROXYGEN_FUZZ_SOURCES "${PROXYGEN_FUZZ_TARGET}.cpp")
    endif()

    add_executable(${PROXYGEN_FUZZ_TARGET}
      "${PROXYGEN_FUZZ_SOURCES}"
    )
    target_link_libraries(${PROXYGEN_FUZZ_TARGET} PRIVATE
      "${PROXYGEN_FUZZ_DEPENDS}"
    )
    target_include_directories(${PROXYGEN_FUZZ_TARGET} PRIVATE
      "${PROXYGEN_FUZZ_INCLUDES}"
    )
    target_compile_options(${PROXYGEN_FUZZ_TARGET} PRIVATE
      "${_PROXYGEN_COMMON_COMPILE_OPTIONS}"
    )
    target_link_libraries(${PROXYGEN_FUZZ_TARGET} PRIVATE
      ${LIBGMOCK_LIBRARIES_NO_MAIN}
      ${LIB_FUZZING_ENGINE}
    )
    target_include_directories(${PROXYGEN_FUZZ_TARGET} SYSTEM PRIVATE
      ${LIBGMOCK_INCLUDE_DIR}
      ${LIBGTEST_INCLUDE_DIR}
    )
    target_compile_definitions(${PROXYGEN_FUZZ_TARGET} PRIVATE ${LIBGMOCK_DEFINES})
endfunction()

proxygen_add_fuzzer(TARGET ProxygenHTTP1xFuzzer
  SOURCES
    ProxygenHTTP1xFuzzer.cpp
  DEPENDS
    codectestutils
    proxygen
)

=== proxygen/httpclient/CMakeLists.txt ===
# Copyright (c) Facebook, Inc. and its affiliates.
# All rights reserved.
#
# This source code is licensed under the BSD-style license found in the
# LICENSE file in the root directory of this source tree.

add_subdirectory(samples)

=== proxygen/httpserver/CMakeLists.txt ===
# Copyright (c) Facebook, Inc. and its affiliates.
# All rights reserved.
#
# This source code is licensed under the BSD-style license found in the
# LICENSE file in the root directory of this source tree.

add_library(
    proxygenhttpserver
    RequestHandlerAdaptor.cpp
    SignalHandler.cpp
    HTTPServerAcceptor.cpp
    HTTPServer.cpp
)
target_compile_options(
    proxygenhttpserver
    PRIVATE
        ${_PROXYGEN_COMMON_COMPILE_OPTIONS}
)
if (BUILD_SHARED_LIBS)
    set_property(TARGET proxygenhttpserver PROPERTY POSITION_INDEPENDENT_CODE ON)
endif()

target_link_libraries(
    proxygenhttpserver
    PUBLIC
        proxygen
)
install(
    TARGETS proxygenhttpserver
    EXPORT proxygen-exports
    DESTINATION lib
)

add_executable(proxygen_push
    samples/push/PushServer.cpp
    samples/push/PushRequestHandler.cpp
)
target_compile_options(
    proxygen_push
    PRIVATE
        ${_PROXYGEN_COMMON_COMPILE_OPTIONS}
)
target_link_libraries(
    proxygen_push
    PUBLIC
        proxygen
        proxygenhttpserver
)
install(
    TARGETS proxygen_push
    EXPORT proxygen-exports
    DESTINATION bin
)

add_executable(proxygen_proxy
    samples/proxy/ProxyServer.cpp
    samples/proxy/ProxyHandler.cpp
)
target_compile_options(
    proxygen_proxy
    PRIVATE
        ${_PROXYGEN_COMMON_COMPILE_OPTIONS}
)
target_link_libraries(
    proxygen_proxy
    PUBLIC
        proxygen
        proxygenhttpserver
)
install(
    TARGETS proxygen_proxy
    EXPORT proxygen-exports
    DESTINATION bin
)

add_executable(proxygen_static
    samples/static/StaticServer.cpp
    samples/static/StaticHandler.cpp
)
target_compile_options(
    proxygen_static
    PRIVATE
        ${_PROXYGEN_COMMON_COMPILE_OPTIONS}
)
target_link_libraries(
    proxygen_static
    PUBLIC
        proxygen
        proxygenhttpserver
)
install(
    TARGETS proxygen_static
    EXPORT proxygen-exports
    DESTINATION bin
)

add_executable(proxygen_echo
    samples/echo/EchoServer.cpp
    samples/echo/EchoHandler.cpp
)
target_compile_options(
    proxygen_echo
    PRIVATE
        ${_PROXYGEN_COMMON_COMPILE_OPTIONS}
)
target_link_libraries(
    proxygen_echo
    PUBLIC
        proxygen
        proxygenhttpserver
)
install(
    TARGETS proxygen_echo
    EXPORT proxygen-exports
    DESTINATION bin
)

if (BUILD_QUIC)
  add_executable(hq
      samples/hq/main.cpp
      samples/hq/FizzContext.cpp
      samples/hq/HQClient.cpp
      samples/hq/HQLoggerHelper.cpp
      samples/hq/HQServer.cpp
      samples/hq/HQParams.cpp
      samples/hq/SampleHandlers.cpp
      samples/hq/PartiallyReliableCurlClient.cpp
  )
  target_compile_options(
      hq
      PRIVATE
          ${_PROXYGEN_COMMON_COMPILE_OPTIONS}
  )
  target_link_libraries(
      hq
      PUBLIC
          proxygen
          proxygencurl
          proxygenhttpserver
          mvfst::mvfst_transport
          mvfst::mvfst_client
          mvfst::mvfst_server
  )
  install(
      TARGETS hq
      EXPORT proxygen-exports
      DESTINATION bin
  )
endif()

file(
    GLOB_RECURSE PROXYGEN_HTTPSERVER_HEADERS_TOINSTALL
    RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
    *.h
)
list(FILTER PROXYGEN_HTTPSERVER_HEADERS_TOINSTALL EXCLUDE REGEX tests/)
list(FILTER PROXYGEN_HTTPSERVER_HEADERS_TOINSTALL EXCLUDE REGEX Mocks.h)
list(FILTER PROXYGEN_HTTPSERVER_HEADERS_TOINSTALL EXCLUDE REGEX samples/)
foreach(header ${PROXYGEN_HTTPSERVER_HEADERS_TOINSTALL})
    get_filename_component(header_dir ${header} DIRECTORY)
    install(FILES ${header} DESTINATION include/proxygen/httpserver/${header_dir})
endforeach()

add_subdirectory(tests)
add_subdirectory(filters/tests)
#add_subdirectory(samples/echo/test)

=== proxygen/lib/CMakeLists.txt ===
# Copyright (c) Facebook, Inc. and its affiliates.
# All rights reserved.
#
# This source code is licensed under the BSD-style license found in the
# LICENSE file in the root directory of this source tree.

file(
    MAKE_DIRECTORY
    ${PROXYGEN_GENERATED_ROOT}/proxygen/lib/http
    ${PROXYGEN_GENERATED_ROOT}/proxygen/lib/utils
)

add_custom_command(
    OUTPUT ${PROXYGEN_GENERATED_ROOT}/proxygen/lib/http/HTTPCommonHeaders.h
    OUTPUT ${PROXYGEN_GENERATED_ROOT}/proxygen/lib/http/HTTPCommonHeaders.cpp
    COMMAND
        ${CMAKE_CURRENT_SOURCE_DIR}/http/gen_HTTPCommonHeaders.sh
        ${CMAKE_CURRENT_SOURCE_DIR}/http/HTTPCommonHeaders.txt
        ${PROXYGEN_FBCODE_ROOT}
        ${PROXYGEN_GENERATED_ROOT}/proxygen/lib/http
    DEPENDS
        ${CMAKE_CURRENT_SOURCE_DIR}/http/gen_HTTPCommonHeaders.sh
        ${CMAKE_CURRENT_SOURCE_DIR}/http/HTTPCommonHeaders.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/utils/gen_perfect_hash_table.sh
        ${CMAKE_CURRENT_SOURCE_DIR}/utils/perfect_hash_table_template.h
        ${CMAKE_CURRENT_SOURCE_DIR}/utils/perfect_hash_table_template.cpp.gperf
    COMMENT "Generating HTTPCommonHeaders.h and HTTPCommonHeaders.cpp"
)
add_custom_command(
    OUTPUT
        ${PROXYGEN_GENERATED_ROOT}/proxygen/lib/utils/TraceEventType.h
        ${PROXYGEN_GENERATED_ROOT}/proxygen/lib/utils/TraceEventType.cpp
        ${PROXYGEN_GENERATED_ROOT}/proxygen/lib/utils/TraceFieldType.h
        ${PROXYGEN_GENERATED_ROOT}/proxygen/lib/utils/TraceFieldType.cpp
    COMMAND
        ${PROXYGEN_PYTHON}
        ${CMAKE_CURRENT_SOURCE_DIR}/utils/gen_trace_event_constants.py
        --output_type=cpp
        --input_files=samples/TraceEventType.txt,samples/TraceFieldType.txt
        --output_scope=proxygen
        --header_path=proxygen/lib/utils
        --install_dir=${PROXYGEN_GENERATED_ROOT}/proxygen/lib/utils
        --fbcode_dir=${PROXYGEN_FBCODE_ROOT}
    WORKING_DIRECTORY
        ${CMAKE_CURRENT_SOURCE_DIR}/utils/
    COMMENT "Generating TraceEventType and TraceFieldType"
)

add_custom_target(
    proxygen-generated
    DEPENDS
        ${PROXYGEN_GENERATED_ROOT}/proxygen/lib/http/HTTPCommonHeaders.h
        ${PROXYGEN_GENERATED_ROOT}/proxygen/lib/http/HTTPCommonHeaders.cpp
        ${PROXYGEN_GENERATED_ROOT}/proxygen/lib/utils/TraceEventType.h
        ${PROXYGEN_GENERATED_ROOT}/proxygen/lib/utils/TraceEventType.cpp
        ${PROXYGEN_GENERATED_ROOT}/proxygen/lib/utils/TraceFieldType.h
        ${PROXYGEN_GENERATED_ROOT}/proxygen/lib/utils/TraceFieldType.cpp
)

if (BUILD_QUIC)
    set(
        HTTP3_SOURCES
        ${HTTP3_SOURCES}
        http/SynchronizedLruQuicPskCache.cpp
        http/HTTP3ErrorCode.cpp
        http/HQConnector.cpp
        http/codec/HQControlCodec.cpp
        http/codec/HQFramedCodec.cpp
        http/codec/HQFramer.cpp
        http/codec/HQStreamCodec.cpp
        http/codec/HQUnidirectionalCodec.cpp
        http/codec/HQUtils.cpp
        http/codec/UnframedBodyOffsetTracker.cpp
        http/session/HQByteEventTracker.cpp
        http/session/HQDownstreamSession.cpp
        http/session/HQSession.cpp
        http/session/HQStreamBase.cpp
        http/session/HQUnidirectionalCallbacks.cpp
        http/session/HQUpstreamSession.cpp
        transport/PersistentQuicPskCache.cpp
    )
  set(
      HTTP3_DEPEND_LIBS
      ${HTTP3_DEPEND_LIBS}
      mvfst::mvfst_transport
      mvfst::mvfst_client
      mvfst::mvfst_fizz_client
      mvfst::mvfst_server
      mvfst::mvfst_codec_types
      mvfst::mvfst_state_machine
  )
endif()

add_library(
    proxygen
    healthcheck/ServerHealthCheckerCallback.cpp
    http/codec/CodecProtocol.cpp
    http/codec/CodecUtil.cpp
    http/codec/compress/GzipHeaderCodec.cpp
    http/codec/compress/HeaderIndexingStrategy.cpp
    http/codec/compress/HeaderTable.cpp
    http/codec/compress/HPACKCodec.cpp
    http/codec/compress/HPACKContext.cpp
    http/codec/compress/HPACKDecodeBuffer.cpp
    http/codec/compress/HPACKDecoderBase.cpp
    http/codec/compress/HPACKDecoder.cpp
    http/codec/compress/HPACKEncodeBuffer.cpp
    http/codec/compress/HPACKEncoderBase.cpp
    http/codec/compress/HPACKEncoder.cpp
    http/codec/compress/HPACKHeader.cpp
    http/codec/compress/Huffman.cpp
    http/codec/compress/Logging.cpp
    http/codec/compress/NoPathIndexingStrategy.cpp
    http/codec/compress/QPACKCodec.cpp
    http/codec/compress/QPACKContext.cpp
    http/codec/compress/QPACKDecoder.cpp
    http/codec/compress/QPACKEncoder.cpp
    http/codec/compress/QPACKHeaderTable.cpp
    http/codec/compress/QPACKStaticHeaderTable.cpp
    http/codec/compress/StaticHeaderTable.cpp
    http/codec/DefaultHTTPCodecFactory.cpp
    http/codec/ErrorCode.cpp
    http/codec/FlowControlFilter.cpp
    http/codec/HeaderConstants.cpp
    http/codec/HeaderDecodeInfo.cpp
    http/codec/HTTP1xCodec.cpp
    http/codec/HTTP2Codec.cpp
    http/codec/HTTP2Constants.cpp
    http/codec/HTTP2Framer.cpp
    http/codec/HTTPChecks.cpp
    http/codec/HTTPCodecFactory.cpp
    http/codec/HTTPCodecFilter.cpp
    http/codec/HTTPCodecPrinter.cpp
    http/codec/HTTPParallelCodec.cpp
    http/codec/HTTPSettings.cpp
    http/codec/SPDYCodec.cpp
    http/codec/SPDYConstants.cpp
    http/codec/TransportDirection.cpp
    http/connpool/ServerIdleSessionController.cpp
    http/connpool/SessionHolder.cpp
    http/connpool/SessionPool.cpp
    http/connpool/ThreadIdleSessionController.cpp
    http/experimental/RFC1867.cpp
    http/HTTPConnector.cpp
    http/HTTPConnectorWithFizz.cpp
    http/HTTPConstants.cpp
    http/HTTPException.cpp
    http/HTTPHeaders.cpp
    http/HTTPMessage.cpp
    http/HTTPMessageFilters.cpp
    http/HTTPMethod.cpp
    http/StatusTypeEnum.cpp
    http/ProxygenErrorEnum.cpp
    http/ProxyStatus.cpp
    http/RFC2616.cpp
    http/session/ByteEvents.cpp
    http/session/ByteEventTracker.cpp
    http/session/CodecErrorResponseHandler.cpp
    http/session/HTTP2PriorityQueue.cpp
    http/session/HTTPDefaultSessionCodecFactory.cpp
    http/session/HTTPDirectResponseHandler.cpp
    http/session/HTTPDownstreamSession.cpp
    http/session/HTTPErrorPage.cpp
    http/session/HTTPEvent.cpp
    http/session/HTTPSessionAcceptor.cpp
    http/session/HTTPSessionBase.cpp
    http/session/HTTPSession.cpp
    http/session/HTTPTransaction.cpp
    http/session/HTTPTransactionEgressSM.cpp
    http/session/HTTPTransactionIngressSM.cpp
    http/session/HTTPUpstreamSession.cpp
    http/session/SecondaryAuthManager.cpp
    http/session/SimpleController.cpp
    http/structuredheaders/StructuredHeadersBuffer.cpp
    http/structuredheaders/StructuredHeadersDecoder.cpp
    http/structuredheaders/StructuredHeadersEncoder.cpp
    http/structuredheaders/StructuredHeadersUtilities.cpp
    http/Window.cpp
    pools/generators/FileServerListGenerator.cpp
    pools/generators/ServerListGenerator.cpp
    services/RequestWorkerThread.cpp
    services/Service.cpp
    services/WorkerThread.cpp
    stats/ResourceStats.cpp
    transport/PersistentFizzPskCache.cpp
    utils/AsyncTimeoutSet.cpp
    utils/Base64.cpp
    utils/CryptUtil.cpp
    utils/Exception.cpp
    utils/HTTPTime.cpp
    utils/Logging.cpp
    utils/ParseURL.cpp
    utils/RendezvousHash.cpp
    utils/Time.cpp
    utils/TraceEventContext.cpp
    utils/TraceEvent.cpp
    utils/WheelTimerInstance.cpp
    utils/ZlibStreamCompressor.cpp
    utils/ZlibStreamDecompressor.cpp
    utils/ZstdStreamCompressor.cpp
    utils/ZstdStreamDecompressor.cpp
    ${HTTP3_SOURCES}
    ${PROXYGEN_GENERATED_ROOT}/proxygen/lib/http/HTTPCommonHeaders.cpp
    ${PROXYGEN_GENERATED_ROOT}/proxygen/lib/utils/TraceEventType.cpp
    ${PROXYGEN_GENERATED_ROOT}/proxygen/lib/utils/TraceFieldType.cpp
    $<TARGET_OBJECTS:proxygen_http_parser>
)
add_dependencies(
    proxygen
    proxygen-generated
    proxygen_http_parser
)
target_include_directories(
    proxygen PUBLIC
    $<BUILD_INTERFACE:${PROXYGEN_FBCODE_ROOT}>
    $<BUILD_INTERFACE:${PROXYGEN_GENERATED_ROOT}>
    $<INSTALL_INTERFACE:include/>
)
target_compile_options(
    proxygen PRIVATE
    ${_PROXYGEN_COMMON_COMPILE_OPTIONS}
)

if (BUILD_SHARED_LIBS)
    set_property(TARGET proxygen PROPERTY POSITION_INDEPENDENT_CODE ON)
endif()

target_link_libraries(
    proxygen PUBLIC
    Folly::folly
    fizz::fizz
    wangle::wangle
    zstd
    Boost::boost
    Boost::iostreams
    -lz
    ${HTTP3_DEPEND_LIBS}
)

# Install the headers, excluding unit testing related headers
file(
    GLOB_RECURSE PROXYGEN_HEADERS_TOINSTALL
    RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
    *.h
)
list(FILTER PROXYGEN_HEADERS_TOINSTALL EXCLUDE REGEX test/)
list(FILTER PROXYGEN_HEADERS_TOINSTALL EXCLUDE REGEX utils/TestUtils.h)
list(FILTER PROXYGEN_HEADERS_TOINSTALL EXCLUDE REGEX .template.h)

# cmake doesn't provide a way to install a list of relative paths to the correct
# location (it will flatten them all into DESTINATION), so we have to manually
# do this for PROXYGEN_HEADERS_TOINSTALL
foreach(header ${PROXYGEN_HEADERS_TOINSTALL})
    get_filename_component(header_dir ${header} DIRECTORY)
    install(FILES ${header} DESTINATION include/proxygen/lib/${header_dir})
endforeach()

install(
    DIRECTORY ${PROXYGEN_GENERATED_ROOT}/proxygen/
    DESTINATION include/proxygen/
)
install(
    TARGETS proxygen
    EXPORT proxygen-exports
    DESTINATION lib
)

add_subdirectory(test)
add_subdirectory(http/test)
add_subdirectory(http/structuredheaders/test)
add_subdirectory(http/connpool/test)
add_subdirectory(http/codec/test)
add_subdirectory(http/codec/compress/test)
add_subdirectory(http/session/test)
add_subdirectory(services/test)
add_subdirectory(utils/test)

=== proxygen/httpclient/samples/CMakeLists.txt ===
# Copyright (c) Facebook, Inc. and its affiliates.
# All rights reserved.
#
# This source code is licensed under the BSD-style license found in the
# LICENSE file in the root directory of this source tree.

add_subdirectory(curl)

=== proxygen/httpserver/tests/CMakeLists.txt ===
# Copyright (c) Facebook, Inc. and its affiliates.
# All rights reserved.
#
# This source code is licensed under the BSD-style license found in the
# LICENSE file in the root directory of this source tree.

proxygen_add_test(TARGET HTTPServerTests
  SOURCES
    HTTPServerTest.cpp
    RequestHandlerAdaptorTest.cpp
  DEPENDS
    codectestutils
    proxygen
    proxygenhttpserver
    proxygencurl
    testmain
    Boost::filesystem
    Boost::regex
)

=== proxygen/lib/test/CMakeLists.txt ===
# Copyright (c) Facebook, Inc. and its affiliates.
# All rights reserved.
#
# This source code is licensed under the BSD-style license found in the
# LICENSE file in the root directory of this source tree.

if(NOT BUILD_TESTS)
    return()
endif()

add_library(testtransport TestAsyncTransport.cpp)
target_include_directories(
    testtransport PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    ${LIBGMOCK_INCLUDE_DIR}
    ${LIBGTEST_INCLUDE_DIR}
)
target_compile_options(
    testtransport PRIVATE
    ${_PROXYGEN_COMMON_COMPILE_OPTIONS}
)
target_link_libraries(testtransport PUBLIC proxygen)

add_library(testmain TestMain.cpp)
target_include_directories(
    testmain PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    ${LIBGMOCK_INCLUDE_DIR}
    ${LIBGTEST_INCLUDE_DIR}
)
target_link_libraries(testmain PUBLIC Folly::folly)
target_compile_options(
    testmain PRIVATE
    ${_PROXYGEN_COMMON_COMPILE_OPTIONS}
)

=== proxygen/httpclient/samples/curl/CMakeLists.txt ===
# Copyright (c) Facebook, Inc. and its affiliates.
# All rights reserved.
#
# This source code is licensed under the BSD-style license found in the
# LICENSE file in the root directory of this source tree.

add_library(proxygencurl CurlClient.cpp)
target_include_directories(
    proxygencurl PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
)
target_compile_options(
    proxygencurl PRIVATE
    ${_PROXYGEN_COMMON_COMPILE_OPTIONS}
)

target_link_libraries(proxygencurl PUBLIC proxygen)

add_executable(proxygen_curl CurlClientMain.cpp)
target_link_libraries(
    proxygen_curl PUBLIC
    proxygencurl
)
target_compile_options(
    proxygen_curl PRIVATE
    ${_PROXYGEN_COMMON_COMPILE_OPTIONS}
)

install(
    TARGETS proxygen_curl
    EXPORT proxygen-exports
    DESTINATION bin
)

=== proxygen/httpclient/samples/pricli/CMakeLists.txt ===
# Copyright (c) Facebook, Inc. and its affiliates.
# All rights reserved.
#
# This source code is licensed under the BSD-style license found in the
# LICENSE file in the root directory of this source tree.

add_executable(proxygen_pricli PriCli.cpp)
target_compile_options(
    proxygen_pricli PRIVATE
    ${_PROXYGEN_COMMON_COMPILE_OPTIONS}
)

=== debian/changelog ===
proxygen (2021.01.04.00-0ubuntu1ppa3~bionic) bionic; urgency=medium

  * Package proxygen for ubuntu bionic

 -- Bartek Kryza <bkryza@gmail.com>  Tue, 10 Aug 2021 22:24:41 +0200

=== debian/control ===
Source: proxygen
Priority: optional
Maintainer: Bartek Kryza <bkryza@gmail.com>
Build-Depends: debhelper (>=9),
    autoconf,
    autoconf-archive,
    automake,
    binutils-dev,
    bison,
    cmake,
    dh-autoreconf,
    flex,
    g++ (>= 5.4.0),
    git,
    gperf,
    libboost-all-dev,
    libdouble-conversion-dev,
    libevent-dev,
    libgflags-dev,
    libgoogle-glog-dev,
    libiberty-dev,
    libjemalloc-dev (>= 5.2.1),
    liblz4-dev,
    liblzma-dev,
    libsnappy-dev,
    libssl-dev (>= 1.1.0),
    libcap-dev,
    libtool,
    make,
    pkg-config,
    unzip,
    libfmt-dev (>= 7.0.1),
    folly-dev (>= 2021.01.04.00),
    fizz-dev (>= 2021.01.04.00),
    wangle-dev (>= 2021.01.04.00),
    wget,
    zlib1g-dev,
    libzstd1-dev,
    libsodium-dev
Standards-Version: 3.9.7
Section: libs
Homepage: https://github.com/facebook/proxygen
Vcs-Git: https://github.com/facebook/proxygen.git

Package: proxygen-dev
Section: libdevel
Architecture: amd64
Depends: ${misc:Depends},
    libdouble-conversion-dev,
    libboost-dev,
    libgflags-dev,
    libjemalloc-dev (>= 5.2.1),
    libssl-dev (>= 1.1.0),
    libgoogle-glog-dev,
    libevent-dev,
    folly-dev (>= 2021.01.04.00),
    fizz-dev (>= 2021.01.04.00),
    wangle-dev (>= 2021.01.04.00)
Description: Facebook's C++ HTTP Libraries
    A collection of C++ HTTP libraries including an easy to use HTTP server.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --buildsystem=cmake --parallel

override_dh_auto_test:


override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DLIB_INSTALL_DIR=lib/x86_64-linux-gnu \
		-DCMAKE_CXX_STANDARD=14 \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DCMAKE_POSITION_INDEPENDENT_CODE=on \
		-DBUILD_SHARED_LIBS=off \
		-DBUILD_TESTS=off \
		-DBUILD_EXAMPLES=off
